#!/usr/bin/env python
#-*- coding:utf-8 -*-

#import pygtk
#pygtk.require("2.0")
#import gtk
from gi.repository import Gtk as gtk
import os
import sys
import uuid
import pango
import commands
import inifile8
from datas import *
from strs import *
from xmls import *

VERSION = "1.9.0"

class SeeMe4(gtk.Window):
    """
        SeeMe Main Window Class
    """
    def __init__(self, sset):
        gtk.Window.__init__(self)
        self.sset = sset
        self.iniver = 0
        self.iniedit = False
        self.prefs_edit = False
        # GtkUIManager and GtkAccelGroup
        self.uimanager = gtk.UIManager()
        accelgroup = self.uimanager.get_accel_group()
        self.add_accel_group(accelgroup)
        # GtkActionGroup
        self.actiongroup = gtk.ActionGroup("seeme_menu")
        # GtkActionEntry
        self.ac = [ ("save", gtk.STOCK_SAVE_AS, "保存(_S)", "<Control>S", "保存", self.on_save),
                    ("reload", gtk.STOCK_REFRESH, "読み直し(_R)", None, "読み直し", self.on_reload),
                    ("textedit", None, "直接編集(_E)", "<Control>E", "直接編集", self.on_textedit),
                    ("buckup_write", None, "バックアップ作成(_S)", None, "バックアップ作成", self.on_buckup_write),
                    ("buckup_read", None, "バックアップ書き戻し(_R)", None, "バックアップ書き戻し", self.on_buckup_read),
                    ("quit", gtk.STOCK_QUIT, "終了(_Q)", "<Control>Q", "さいなら", self.on_quit),
                    ("item_new", gtk.STOCK_NEW, "新規アイテム(_N)", "<Control>N", "新規アイテム", self.on_item_new),
                    ("item_up", gtk.STOCK_GO_UP, "上に移動(_U)", "<Control>Up", "上に移動", self.on_item_up),
                    ("item_down", gtk.STOCK_GO_DOWN, "下に移動(_D)", "<Control>Down", "下に移動", self.on_item_down),
                    ("item_delete", gtk.STOCK_CLEAR, "削除(_l)", "<Control>Delete", "削除", self.on_item_delete),
                    ("apply", gtk.STOCK_OK, "リストに反映(_S)", "<Control>Return", "リストに反映(_S)", self.on_edit_accept),
                    ("profile_edit", None, "プロファイルの編集(_E)", None, "プロファイルの編集", self.on_profile_edit),
                    ("online_help", gtk.STOCK_HELP, "オンラインヘルプ(_H)", "F1", "オンラインヘルプ", self.on_online_help),
                    ("about", gtk.STOCK_ABOUT, "情報(_B)", "<Control>B", "情報", self.on_about),
                    ("file", None, "ファイル(_F)"),
                    ("buckup", None, "バックアップ(_B)"),
                    ("edit", None, "編集(_E)"),
                    ("profile", None, "プロファイル(_P)"),
                    ("help", None, "ヘルプ(_H)") ]
        self.actiongroup.add_actions(self.ac)
        self.uimanager.insert_action_group(self.actiongroup, 0)
        self.uimanager.add_ui_from_string(menu_xml)
        # GtkNoteBook
        note = gtk.Notebook()
        page = []
        for i in range(3):
            tab = gtk.Label(TAB_LABELS[i])
            page.append(gtk.VBox())
            note.append_page(page[i], tab)
        # page pack
        # GtkListStore
        self.custome_liststore = CreateListStore()
        self.custome_treeview = gtk.TreeView()
        #self.custome_treeview.set_reorderable(True)
        self.default_liststore = CreateListStore()
        self.default_treeview = gtk.TreeView()
        # on ScrolledWindow TreeView
        self.adjustment1 = gtk.Adjustment()
        self.sw1 = gtk.ScrolledWindow(self.adjustment1)
        self.sw1.set_policy(gtk.PolicyType.AUTOMATIC, gtk.PolicyType.AUTOMATIC)
        self.adjustment2 = gtk.Adjustment()
        self.sw2 = gtk.ScrolledWindow(self.adjustment2)
        self.sw2.set_policy(gtk.PolicyType.AUTOMATIC, gtk.PolicyType.AUTOMATIC)
        self.sw1.add(self.custome_treeview)
        self.sw2.add(self.default_treeview)
        page[0].pack_start(self.sw1, True, True, 0)
        page[1].pack_start(self.sw2, True, True, 0)
        self.create_treeview(self.default_treeview, self.default_liststore)
        self.create_treeview(self.custome_treeview, self.custome_liststore)
        self.custome_treeview.get_selection().connect("changed", self.selection_changeed)
        self.default_treeview.get_selection().connect("changed", self.selection_changeed2)
        # IniEditor
        self.editor = IniEditor()
        self.editor.button.connect("clicked", self.on_edit_accept)
        page[0].pack_start(self.editor, False, True, 0)
        # default search.ini UNIQUEID
        ulabel = gtk.Label("UNIQUEID")
        self.def_uid_entry = gtk.Entry()
        uhbox = gtk.HBox()
        uhbox.pack_start(ulabel, False, False, 0)
        uhbox.pack_start(self.def_uid_entry, True, True, 0)
        page[1].pack_start(uhbox, False, True, 0)
        # DEditor
        self.deditor = DEditor()
        page[2].set_border_width(10)
        page[2].pack_start(self.deditor, False, True, 0)
        self.deditor.edit_editor.set_text(sset.texteditor)
        self.deditor.set_radio_num(sset.verbtext)
        # main packing
        vbox = gtk.VBox()
        menubar = self.uimanager.get_widget("/MenuBar")
        toolbar = self.uimanager.get_widget("/ToolBar")
        self.statusbar = gtk.Statusbar()
        vbox.pack_start(menubar, False, True, 0)
        vbox.pack_start(toolbar, False, True, 0)
        vbox.pack_start(note, True, True, 0)
        vbox.pack_start(self.statusbar, False, True, 0)
        self.add(vbox)
        # self
        path = os.path.join(os.path.dirname( __file__ ), "seeme.xpm")
        self.set_icon_from_file(path)
        self.set_title("seemex")
        self.resize(self.sset.width, self.sset.height)
        self.move(self.sset.left, self.sset.top)
        self.connect("delete-event", self.on_quit)
        self.show_all()
        # read
        self.refresh()
        # After Read
        self.deditor.edit_uid1.connect("changed", self.edit_uid_changed)
        self.deditor.edit_uid2.connect("changed", self.edit_uid_changed)
        # no select is raise
        self.custome_treeview.get_selection().select_path(0)

    def close(self):
        if self.iniedit:
            r = self.messagebox_yn(MESSAGE_CLOSEING)
            if r == gtk.RESPONSE_YES:
                self.on_save(self)
        # mkdir
        inipath = os.path.expanduser("~/.seeme")
        if not os.path.exists(inipath):
            os.mkdir(inipath)
        # Read seeme4.ini
        inipath += "/seeme4.ini"
        ini = inifile8.Inifile(inipath)
        try:
            ini.write_int("Version", "File Version", 4)
            x, y = self.get_position()
            ini.write_int("Window", "Left", x)
            ini.write_int("Window", "Top", y)
            cx, cy = self.get_size()
            ini.write_int("Window", "Width", cx)
            ini.write_int("Window", "Height", cy)
            ini.write_str("Path", "Default1", self.sset.default_path)
            ini.write_str("Path", "Custome1", self.sset.custome_path)
            ini.write_str("Path", "Lang1", self.sset.lang_path)
            ini.write_str("Setting", "Editor", self.deditor.edit_editor.get_text())
            ini.write_int("Setting", "Verbtext", self.deditor.get_radio_num())
            ini.save()
        except Exception, s:
            self.messagebox("%s" % s)
        gtk.main_quit()


########################################################################
#
#                          Functions
#
########################################################################


    def messagebox(self, text, error=False):
        icon = gtk.MessageType.WARNING
        if error:
            icon = gtk.MessageType.ERROR
        dlg = gtk.MessageDialog(
                self,
                gtk.DialogFlags.MODAL,
                icon,
                gtk.ButtonsType.OK,
                text)
        dlg.set_title(MESSAGEDLG_TITLE)  
        r = dlg.run()  
        dlg.destroy()

    def messagebox_yn(self, text):
        dlg = gtk.MessageDialog(
                self,
                gtk.DialogFlags.MODAL,
                gtk.MessageType.QUESTION, 
                gtk.ButtonsType.YES_NO,
                text)
        dlg.set_title(MESSAGEDLG_TITLE)  
        r = dlg.run()  
        dlg.destroy()
        return r

    def create_treeview(self, treeview, liststore):
        for i in range(4):
            column = gtk.TreeViewColumn()
            column.set_title(COLUMN_NAMES[i])
            treeview.append_column(column)
            # cell
            if i == 0:
                cell = gtk.CellRendererToggle()
                cell.connect("toggled", self.on_toggled, liststore)
            else:
                cell = gtk.CellRendererText()
            column.pack_start(cell, True)
            if i == 0:
                column.add_attribute(cell, "active", 0)
            else:
                column.add_attribute(cell, "text", i)
                if i == 1:
                    column.set_cell_data_func(cell, self.on_textrender_name)
                else:
                    column.set_cell_data_func(cell, self.on_textrender_etc)
        treeview.set_model(liststore)

    def read_default_searchini(self):
        self.default_liststore.clear()
        inipath = self.sset.default_path
        lngpath = self.sset.lang_path
        if os.path.exists(inipath):
            ini = inifile8.Inifile(inipath)
            lng = inifile8.InifileReader(lngpath)
            try:
                self.iniver = ini.read_int("Version", "File Version", 0)
                i = 0
                while 1:
                    i += 1
                    s = "Search Engine %i" % i
                    if not ini.section_exists(s):
                        break
                    t = ini.read_str(s, "Key", "")
                    if t == "":
                        continue
                    en = Engine();
                    en.nameid = ini.read_int(s, "Nameid", 0);
                    if en.nameid != 0:
                        # Get View Name from *.lng
                        if en.nameid == 17171:
                            en.name = lng.read_str("Translation", "1632215285", "")
                        elif en.nameid == 17183:
                            en.name = lng.read_str("Translation", "-1971470391", "")
                        elif en.nameid == 71103:
                            en.name = lng.read_str("Translation", "-1453429782", "")
                        else:
                            en.name = lng.read_str("Translation", str(en.nameid), "")
                        if en.name == "":
                            n = -1752227277 - en.nameid;
                            en.name = lng.read_str("Translation", str(n), "")
                    else:
                        en.name = ini.read_str(s, "Name", "")
                    en.key = t
                    en.url = ini.read_str(s, "URL", "")
                    en.query = ini.read_str(s, "Query", "")
                    en.post = ini.read_bool(s, "Is post", False)
                    en.endsep = ini.read_bool(s, "Has endseparator", False)
                    en.encode = ini.read_str(s, "Encoding", "utf-8")
                    en.stype = ini.read_int(s, "Search Type", 0)
                    en.pos = ini.read_int(s, "Position", -1)
                    en.verb = ini.read_int(s, "Verbtext", 0)
                    en.delete = True #！
                    en.unique = ini.read_str(s, "UNIQUEID", "")
                    en.icon = ini.read_str(s, "ICON", "")
                    en.usetld = ini.read_int(s, "UseTLD", 0)
                    self.default_liststore.add(en)
            except Exception, s:
                self.messagebox("%s" % s)
                sys.exit()

    def read_custome_searchini(self):
        self.custome_liststore.clear()
        inipath = self.sset.custome_path
        if os.path.exists(inipath):
            ini = inifile8.Inifile(inipath)
            try:
                if self.iniver == 0:
                    self.iniver = ini.read_int("Version", "File Version", 0)
                i = 0
                # v10.60
                d1 = ini.read_str("Options", "Default Search", "")
                d2 = ini.read_str("Options", "Speed Dial Search", "")
                self.deditor.edit_uid1.set_text(d1)
                self.deditor.edit_uid2.set_text(d2)
                #
                while 1:
                    i += 1
                    s = "Search Engine %i" % i
                    if not ini.section_exists(s):
                        break
                    t = ini.read_str(s, "Key", "")
                    if t == "":
                        continue
                    en = Engine();
                    en.name = ini.read_str(s, "Name", "")
                    en.key = t
                    en.url = ini.read_str(s, "URL", "")
                    en.query = ini.read_str(s, "Query", "")
                    en.post = ini.read_bool(s, "Is post", False)
                    en.endsep = ini.read_bool(s, "Has endseparator", False)
                    en.encode = ini.read_str(s, "Encoding", "utf-8")
                    en.stype = ini.read_int(s, "Search Type", 0)
                    en.pos = ini.read_int(s, "Position", -1)
                    en.nameid = ini.read_int(s, "Nameid", 0)
                    en.verb = ini.read_int(s, "Verbtext", 0)
                    en.delete = not ini.read_bool(s, "Deleted", False)
                    en.unique = ini.read_str(s, "UNIQUEID", "")
                    en.icon = ini.read_str(s, "ICON", "")
                    en.usetld = ini.read_int(s, "UseTLD", 0)
                    # Default Delete as No append
                    default_delete = False
                    if not en.delete:
                        for row in self.default_liststore:
                            uid = row[13]
                            if uid == en.unique:
                                row[0] = False
                                default_delete = True
                                break
                    if not default_delete:
                        self.custome_liststore.add(en)
            except Exception, s:
                self.messagebox("%s" % s)
                sys.exit()

    def create_uuid(self):
        uuids = []
        for row in self.default_liststore:
            uuids.append(row[13])
        for row in self.custome_liststore:
            uuids.append(row[13])
        while 1:
            result = str(uuid.uuid4()).upper().replace("-", "")
            if result in uuids:
                continue
            return result

    def find_of_key(self, key):
        keys = []
        for row in self.default_liststore:
            if key == row[2]:
                if row[0]:
                    return True
        i = 0
        for row in self.custome_liststore:
            if key == row[2]:
                if row[0]:
                    selection = self.custome_treeview.get_selection()
                    model, it = selection.get_selected()
                    path = model.get_path(it)
                    if path[0] != i:
                        return True
            i = i + 1
        return False

    def refresh(self):
        self.read_default_searchini()
        self.read_custome_searchini()
        self.statusbar.push(0, "search.ini version %d" % self.iniver)


########################################################################
#
#                          Menu and Toolbar
#
########################################################################


    def on_save(self, widget, event=None):
        r = commands.getoutput("ps ax")
        if "/usr/lib/opera/opera" in r:
            # stating Opera
            r = self.messagebox_yn(MESSAGE_INIT_OPERA)
            if r != gtk.RESPONSE_YES:
                return
        inipath = self.sset.custome_path
        ini = inifile8.Inifile(inipath)
        try:
            ini.write_int("Version", "File Version", self.iniver)
            # v10.60
            if self.prefs_edit:
                ps = self.deditor.edit_uid1.get_text()
                if ps == "":
                    ini.erase_key("Options", "Default Search")
                else:
                    ini.write_str("Options", "Default Search", ps)
                ps = self.deditor.edit_uid2.get_text()
                if ps == "":
                    ini.erase_key("Options", "Speed Dial Search")
                else:
                    ini.write_str("Options", "Speed Dial Search", ps)
            self.prefs_edit = False
            # end
            i = 0
            for row in self.default_liststore:
                # Deleted のみ書き込み
                if row[0] == False:
                    i += 1
                    s = "Search Engine %i" % i
                    ini.write_str(s, "UNIQUEID", row[13])
                    if row[10] == 0:
                        ini.write_str(s, "Name", row[1])
                    else:
                        ini.write_str(s, "Name", "")
                    ini.write_int(s, "Verbtext", row[11])
                    ini.write_str(s, "URL", row[3])
                    ini.write_str(s, "Query", row[4])
                    ini.write_str(s, "Key", row[2])
                    ini.write_bool(s, "Is post", row[5])
                    if row[14] == 0:
                        ini.erase_key(s, "UseTLD")
                    else:
                        ini.write_int(s, "UseTLD", row[14])
                    if row[6]:
                        ini.write_int(s, "Has endseparator", -1)
                    else:
                        ini.write_int(s, "Has endseparator", 0)
                    ini.write_str(s, "Encoding", row[7])
                    ini.write_int(s, "Search Type", row[8])
                    ini.write_int(s, "Position", row[9])
                    ini.write_int(s, "Nameid", row[10])
                    ini.write_int(s, "Deleted", 1)
            for row in self.custome_liststore:
                i += 1
                s = "Search Engine %i" % i
                ini.write_str(s, "UNIQUEID", row[13])
                ini.write_str(s, "Name", row[1])
                num = self.deditor.get_radio_num()
                if num == 2:
                    ini.write_int(s, "Verbtext", -1988219522)
                elif num == 1:
                    ini.write_int(s, "Verbtext", 0)
                else:
                    ini.write_int(s, "Verbtext", row[11])
                ini.write_str(s, "URL", row[3])
                ini.write_str(s, "Query", row[4])
                ini.write_str(s, "Key", row[2])
                ini.write_bool(s, "Is post", row[5])
                if row[14] == 0:
                    ini.erase_key(s, "UseTLD")
                else:
                    ini.write_int(s, "UseTLD", row[14])
                if row[6]:
                    ini.write_int(s, "Has endseparator", -1)
                else:
                    ini.write_int(s, "Has endseparator", 0)
                ini.write_str(s, "Encoding", row[7])
                ini.write_int(s, "Search Type", row[8])
                ini.write_int(s, "Position", row[9])
                ini.write_int(s, "Nameid", row[10])
                if row[12] == "":
                    ini.erase_key(s, "ICON")
                else:
                    ini.write_str(s, "ICON", row[12])
                if row[0]:
                    ini.write_int(s, "Deleted", 0)
                else:
                    ini.write_int(s, "Deleted", 1)
            while 1:
                # Default Delete as No append
                i += 1
                s = "Search Engine %i" % i
                if not ini.section_exists(s):
                    break
                ini.erase_section(s)
            ini.add_header(HEADER_STR)
            ini.save()
        except Exception, s:
            self.messagebox("%s" % s)
            sys.exit()
        self.appry()

    def on_reload(self, widget, event=None):
        self.refresh()
        self.appry()

    def on_textedit(self, widget, event=None):
        exe = self.deditor.edit_editor.get_text()
        if exe == "":
            os.system("xdg-open %s" % self.sset.custome_path)
            self.close()
        else:
            #os.spawnlp(os.P_NOWAIT, exe , exe, self.sset.custome_path)
            os.system("%s %s &" % (exe, self.sset.custome_path) )
            self.close()

    def on_buckup_write(self, widget, event=None):
        inipath = os.environ["HOME"] + "/.seeme"
        if not os.path.exists(inipath):
            os.mkdir(inipath)
        inipath += "/.search.ini"
        os.system("cp %s %s" % (self.sset.custome_path, inipath))
        self.messagebox(MESSAGE_CREATE_BUCKUP)

    def on_buckup_read(self, widget, event=None):
        inipath = os.environ["HOME"] + "/.seeme/.search.ini"
        if os.path.exists(inipath):
            os.system("cp %s %s" % (inipath, self.sset.custome_path))
            self.read_default_searchini()
            self.read_custome_searchini()
        else:
            self.messagebox(MESSAGE_NO_BUCKUPFILE)

    def on_quit(self, widget, event=None):
        self.close()
        return True

    def on_item_new(self, widget, event=None):
        uid = self.create_uuid()
        num = self.deditor.get_radio_num()
        if num == 2:
            num = -1988219522
        else:
            num = 0
        en = Engine(verb=num, unique= uid)
        it = self.custome_liststore.add(en)
        # select
        selection = self.custome_treeview.get_selection()
        selection.select_iter(it)
        # Update Scroll Bar
        while gtk.events_pending():
            gtk.main_iteration()
        # Get GtkAdjustment
        adjustment = self.custome_treeview.get_vadjustment()
        # calc
        model, it2 = selection.get_selected()
        n = model.get_path(it2)[0]
        page_size = adjustment.get_property("page_size")
        column = self.custome_treeview.get_column(1)
        column_height = column.cell_get_size(gtk.gdk.Rectangle())[4]
        sc = column_height * n
        # New Item in View?
        v = adjustment.get_value()
        h = page_size + v - (column_height * 2)
        if sc >= h:
            adjustment.set_value(sc - page_size + (column_height * 2))
        # Focus
        self.set_focus(self.editor.edit_name)
        self.change()

    def on_item_up(self, widget, event=None):
        selection = self.custome_treeview.get_selection()
        model, it = selection.get_selected()
        if it:
            path = model.get_path(it)
            if path[0] > 0:
                path2 = (path[0]-1, )
                itprev = model.get_iter(path2)
                if itprev:
                    model.swap(it, itprev)
                    self.change()
        else:
            self.messagebox(MESSAGE_NON_SELECT)

    def on_item_down(self, widget, event=None):
        selection = self.custome_treeview.get_selection()
        model, it = selection.get_selected()
        if it:
            itnext = model.iter_next(it)
            if itnext:
                model.swap(it, itnext)
                self.change()
        else:
            self.messagebox(MESSAGE_NON_SELECT)

    def on_item_delete(self, widget, event=None):
        selection = self.custome_treeview.get_selection()
        model, it = selection.get_selected()
        if it:
            itnext = model.iter_next(it)
            if itnext:
                model.remove(it)
                selection.select_iter(itnext)
                self.change()
            else:
                row = model.get_path(it)[0]
                model.remove(it)
                self.change()
                if row > 0:
                    selection.select_path(row-1)

    def on_edit_accept(self, widget, event=None):
        model, it = self.custome_treeview.get_selection().get_selected()
        if it:
            key = self.editor.edit_key.get_text()
            if self.find_of_key(key):
                self.messagebox(MESSAGE_CONFLICT, error=True)
                return
            self.custome_liststore.set_value(it, 1, self.editor.edit_name.get_text())
            self.custome_liststore.set_value(it, 2, key)
            self.custome_liststore.set_value(it, 3, self.editor.edit_url.get_text())
            self.custome_liststore.set_value(it, 4, self.editor.edit_query.get_text())
            self.custome_liststore.set_value(it, 5, self.editor.check_post.get_active())
            self.custome_liststore.set_value(it, 6, self.editor.check_separator.get_active())
            self.custome_liststore.set_value(it, 7, self.editor.edit_encode.get_text())
            self.custome_liststore.set_value(it, 8, int(self.editor.edit_type.get_text()))
            self.custome_liststore.set_value(it, 12, self.editor.edit_icon.get_text())
            self.custome_liststore.set_value(it, 13, self.editor.edit_uniqueid.get_text())
            self.change()
        else:
            self.messagebox(MESSAGE_NON_EDITABLE)

    def on_profile_edit(self, widget, event=None):
        dlg = WelcomeDlg(self.sset, CHANGE_DESCRIPTION)
        dlg.entrys[0].set_text(self.sset.default_path)
        dlg.entrys[1].set_text(self.sset.custome_path)
        dlg.entrys[2].set_text(self.sset.lang_path)
        try:
            if dlg.w.run() == gtk.RESPONSE_ACCEPT:
                self.sset.default_path = dlg.entrys[0].get_text()
                self.sset.custome_path = dlg.entrys[1].get_text()
                self.sset.lang_path =    dlg.entrys[2].get_text()
                self.refresh()
            else:
                return
        except Exception, s:
            messagebox("%s" % s)
        finally:
            dlg.w.destroy()

    def on_online_help(self, widget, event=None):
        os.system("xdg-open http://palepoli.skr.jp/seeme/index.php")

    def on_about(self, widget, event=None):
        url = "http://palepoli.skr.jp/"
        w = gtk.AboutDialog()
        w.set_transient_for(self)
        w.set_program_name("seemex")
        w.set_version(VERSION)
        w.set_copyright("Copyright(C) 2009-2011 sasakima-nao")
        w.set_license("GPL")
        w.set_logo(self.get_icon())
        v = "GTK+ Version {0}.{1}.{2}".format(
                gtk.get_major_version(),
                gtk.get_minor_version(),
                gtk.get_micro_version())
        w.set_comments(v)
        w.set_website(url)
        w.set_website_label(url)
        w.run()
        w.destroy()


########################################################################
#
#                            About Signal
#
########################################################################


    def change(self):
        self.iniedit = True
        self.set_title("seemex - (更新)")

    def appry(self):
        self.iniedit = False
        self.set_title("seemex")

    def edit_uid_changed(self, widget, event=None):
        self.prefs_edit = True
        self.change()

    def selection_changeed(self, widget, event=None):
        """
            [en.Deleted, en.name, en.Key, en.URL, en.Query,
            en.Is_post, en.Has_endseparator, en.Encoding, en.Search_Type, en.Position,
            en.nameid, en.Verbtext, en.ICON, en.UNIQUEID, en.UseTLD]
        """
        model, it = self.custome_treeview.get_selection().get_selected()
        if it:
            self.editor.edit_name.set_text(self.custome_liststore.get_value(it, 1))
            self.editor.edit_key.set_text(self.custome_liststore.get_value(it, 2))
            self.editor.edit_url.set_text(self.custome_liststore.get_value(it, 3))
            self.editor.edit_query.set_text(self.custome_liststore.get_value(it, 4))
            self.editor.check_post.set_active(self.custome_liststore.get_value(it, 5))
            self.editor.check_separator.set_active(self.custome_liststore.get_value(it, 6))
            self.editor.edit_encode.set_text(self.custome_liststore.get_value(it, 7))
            self.editor.edit_type.set_text(str(self.custome_liststore.get_value(it, 8)))
            self.editor.edit_icon.set_text(self.custome_liststore.get_value(it, 12))
            self.editor.edit_uniqueid.set_text(self.custome_liststore.get_value(it, 13))
            self.editor.etc_label.set_text("<span color=\"darkgreen\">Verfbtext = %d  Position = %d  NameID = %d  UseTLD = %d  </span>" %
                (self.custome_liststore.get_value(it, 11), self.custome_liststore.get_value(it, 9),
                self.custome_liststore.get_value(it, 10), self.custome_liststore.get_value(it, 14)))
            self.editor.etc_label.set_use_markup(True)

    def selection_changeed2(self, widget, event=None):
        model, it = self.default_treeview.get_selection().get_selected()
        if it:
            self.def_uid_entry.set_text(self.default_liststore.get_value(it, 13))


########################################################################
#
#                               Render
#
########################################################################


    def on_toggled(self, cell, path, model):
        # Click GtkCheckButton
        it = model.get_iter_from_string(path)
        b = model.get_value(it, 0)
        model.set_value(it, 0, not b)
        self.change()

    def on_textrender_name(self, column, cell, model, it, data):
        if not model.get_value(it, 0) or model.get_value(it, 2) == "":
            cell.set_property("sensitive", False)
        else:
            cell.set_property("sensitive", True)
        if model.get_value(it, 6):
            cell.set_property("underline", pango.UNDERLINE_SINGLE)
        else:
            cell.set_property("underline", pango.UNDERLINE_NONE)

    def on_textrender_etc(self, column, cell, model, it, data):
        if not model.get_value(it, 0) or model.get_value(it, 2) == "":
            cell.set_property("sensitive", False)
        else:
            cell.set_property("sensitive", True)


########################################################################
#
#                               Editor
#
########################################################################


class IniEditor(gtk.Table):
    """
        Editor
    """
    def __init__(self):
        gtk.Table.__init__(self, 6, 7)
        label = []
        for i in range(len(EDITOR_LABELS)):
            l = gtk.Label(EDITOR_LABELS[i])
            label.append(l)
        self.edit_name = gtk.Entry()
        self.attach(self.edit_name, 1, 2, 0, 1)
        self.edit_key = gtk.Entry()
        self.attach(self.edit_key, 3, 5, 0, 1, 0)
        self.edit_url = gtk.Entry()
        self.attach(self.edit_url, 1, 6, 1, 2)
        self.edit_query = gtk.Entry()
        self.attach(self.edit_query, 1, 6, 2, 3)
        self.edit_uniqueid = gtk.Entry()
        self.attach(self.edit_uniqueid, 1, 5, 3, 4)
        self.check_post = gtk.CheckButton(EDITOR_CHECKS[0])
        self.attach(self.check_post, 5, 6, 3, 4, gtk.AttachOptions.FILL)
        self.edit_icon = gtk.Entry()
        self.attach(self.edit_icon, 1, 5, 4, 5)
        self.check_separator = gtk.CheckButton(EDITOR_CHECKS[1])
        self.attach(self.check_separator, 5, 6, 4, 5, gtk.AttachOptions.FILL)
        self.edit_encode = gtk.Entry()
        self.attach(self.edit_encode, 1, 4, 5, 6)
        self.edit_type = gtk.Entry()
        self.attach(self.edit_type, 5, 6, 5, 6, 0)
        # Label
        self.attach(label[0], 0, 1, 0, 1, gtk.AttachOptions.FILL)
        self.attach(label[1], 2, 3, 0, 1, 0, xpadding=10)
        self.attach(label[2], 0, 1, 1, 2, 0)
        self.attach(label[3], 0, 1, 2, 3, 0)
        self.attach(label[4], 0, 1, 3, 4, 0)
        self.attach(label[5], 0, 1, 4, 5, 0)
        self.attach(label[6], 0, 1, 5, 6, 0)
        self.attach(label[7], 4, 5, 5, 6, 0)
        self.etc_label = gtk.Label("<span color=\"darkgreen\">Verfbtext =  Position =  NameID =  UseTLD =  </span>")
        self.etc_label.set_use_markup(True)
        #self.etc_label.set_justify(gtk.JUSTIFY_LEFT)
        self.etc_label.set_alignment(0.1, 1.0)
        self.attach(self.etc_label, 0, 6, 6, 7)
        # Button
        self.button = gtk.Button("リストに反映")
        self.attach(self.button, 5, 6, 0, 1, 0)

class CLabel(gtk.Label):
    """
        GtkLabel markup and alignment
    """
    def __init__(self, s=None):
        gtk.Label.__init__(self, s)
        self.set_use_markup(True)
        self.set_alignment(0.0, 0.5)
        self.set_padding(0, 5)

class DEditor(gtk.VBox):
    """
        Default Search Engine Edit
    """
    def __init__(self):
        gtk.VBox.__init__(self)
        label1 = CLabel(MARKUP_LINUX_A)
        self.pack_start(label1, False, False, 0)
        table = gtk.Table(2, 2)
        table.set_border_width(5)
        self.edit_uid1 = gtk.Entry()
        self.edit_uid2 = gtk.Entry()
        label2 = gtk.Label(DEFAULT_SEARCH)
        label3 = gtk.Label(DEFAULT_SEARCH_SD)
        label2.set_alignment(0.0, 0.5)
        label3.set_alignment(0.0, 0.5)
        table.attach(label2, 0, 1, 0, 1, gtk.AttachOptions.FILL)
        table.attach(label3, 0, 1, 1, 2, gtk.AttachOptions.FILL)
        table.attach(self.edit_uid1, 1, 2, 0, 1)
        table.attach(self.edit_uid2, 1, 2, 1, 2)
        self.pack_start(table, False, False, 0)
        label4 = CLabel(MARKUP_LINUX_B)
        self.pack_start(label4, False, False, 0)
        #
        self.radio = []
        for i in range(3):
            r = gtk.RadioButton(label=RADIO_LABELS[i])
            self.radio.append(r)
            #if not i == 0:
            #    r.set_group(self.radio[0])
            #r.set_group(self.radio)
            self.pack_start(r, False, True, 0)
        #
        label5 = CLabel(MARKUP_LINUX_C)
        self.pack_start(label5, False, False, 0)
        self.edit_editor = gtk.Entry()
        self.pack_start(self.edit_editor, False, True, 0)

    def get_radio_num(self):
        if self.radio[1].get_active():
            return 1
        elif self.radio[2].get_active():
            return 2
        else:
            return 0

    def set_radio_num(self, num):
        self.radio[num].set_active(True)

########################################################################
#
#                               Welcome
#
########################################################################


class WelcomeDlg():
    """
        Welcome Dialog
    """
    def __init__(self, sset, text):
        self.w = gtk.Dialog(
                WELCOME_TITLE, 
                None,
                gtk.DialogFlags.MODAL,
                (gtk.STOCK_CANCEL, gtk.ResponseType.REJECT,
                gtk.STOCK_OK, gtk.ResponseType.ACCEPT) )
        description = gtk.Label(text)
        vbox = self.w.get_content_area()
        vbox.pack_start(description, False, False, 0)
        #self.w.vbox.pack_start(description, False, False, 0)
        sp = gtk.HSeparator()
        vbox.pack_start(sp, False, True, 0)
        self.entrys = []
        for name in INI_NAMES:
            hbox = gtk.HBox()
            label = gtk.Label(name)
            label.set_size_request(150, -1)
            entry = gtk.Entry()
            hbox.pack_start(label, False, False, 0)
            hbox.pack_start(entry, True, True, 0)
            vbox.pack_start(hbox, False, False, 0)
            self.entrys.append(entry)
        if sset.default_path == "":
            self.entrys[0].set_text("/usr/share/opera/locale/ja/search.ini")
        else:
            self.entrys[0].set_text(sset.default_path)
        if sset.custome_path == "":
            s = os.path.expanduser("~/.opera/search.ini")
            self.entrys[1].set_text(s)
        else:
            self.entrys[1].set_text(sset.custome_path)
        if sset.lang_path == "":
            self.entrys[2].set_text("/usr/share/opera/locale/ja/ja.lng")
        else:
            self.entrys[2].set_text(sset.lang_path)
        self.w.set_size_request(500, -1)
        self.w.show_all()

########################################################################
#
#                               main
#
########################################################################


def messagebox(text):
    dlg = gtk.MessageDialog(
            None,
            gtk.DialogFlags.MODAL,
            gtk.MessageType.ERROR,
            gtk.ButtonsType.OK,
            text)
    dlg.set_title(MESSAGEDLG_TITLE)  
    r = dlg.run()  
    dlg.destroy()

def main():
    inipath = os.path.expanduser("~/.seeme/seeme4.ini")
    sset = SeeMeSetting()
    ini = inifile8.Inifile(inipath)
    try:
        sset.version = ini.read_int("Version", "File Version", 0)
        sset.width = ini.read_int("Window", "Width", 500)
        sset.height = ini.read_int("Window", "Height", 500)
        sset.top = ini.read_int("Window", "Top", 100)
        sset.left = ini.read_int("Window", "Left", 100)
        sset.default_path = ini.read_str("Path", "Default1", "")
        sset.custome_path = ini.read_str("Path", "Custome1", "")
        sset.lang_path = ini.read_str("Path", "Lang1", "")
        sset.texteditor = ini.read_str("Setting", "Editor", "")
        sset.verbtext = ini.read_int("Setting", "Verbtext", 0)
    except Exception, s:
        messagebox("%s" % s)
        sys.exit()
    if sset.version < 4:
        # New
        if sset.version == 0:
            description = WELCOME_DESCRIPTION
        else:
            description = CHANGE_DESCRIPTION
        dlg = WelcomeDlg(sset, description)
        try:
            if dlg.w.run() == gtk.ResponseType.ACCEPT:
                sset.default_path = dlg.entrys[0].get_text()
                sset.custome_path = dlg.entrys[1].get_text()
                sset.lang_path =    dlg.entrys[2].get_text()
            else:
                messagebox("bye !")
                sys.exit()
        except Exception, s:
            messagebox("%s" % s)
        finally:
            dlg.w.destroy()
    SeeMe4(sset)
    gtk.main()

if __name__ == "__main__":
    main()
